#!/usr/bin/python
# coding=utf-8
# messprogramm.py
#------------------------------------------------------------

import os, sys, time
import tornado.httpserver, tornado.websocket, tornado.ioloop, tornado.web
import datetime, json, sqlite3
import RPi.GPIO as gp


def sensorDateiAuslesen():
      
    # 1-wire Slave Datei lesen
    file = open('/sys/bus/w1/devices/28-000005d2e508/w1_slave')
    filecontent = file.read()
    file.close()

    # Temperaturwerte auslesen und konvertieren
    stringvalue = filecontent.split("\n")[1].split(" ")[9]
    temperature = float(stringvalue[2:]) / 1000

    # Temperatur ausgeben
    rueckgabeWert = '%6.2f' % temperature #Temperaturwert auf 2 Dezimalstellen formatiert

    return (rueckgabeWert)


def aktuelleTemperatur():
      
    messDaten = sensorDateiAuslesen()

    systemWertMax = maxTempSensor - float(messDaten)
    systemWertMin = float(messDaten) - minTempSensor

    tempStatus=ledAusgabe(float(messDaten))
    
    return(messDaten, str(tempStatus), str(systemWertMin), str(systemWertMax))

def aktuelleSystemZeit():
    zeitpunktMessung = time.localtime()
    jahr, monat, tag = zeitpunktMessung[0:3]
    stunde, minute, sekunde = zeitpunktMessung[3:6]
    systemUhrzeit = str(stunde) + ":" + str(minute) + ":" + str(sekunde)
    systemDatum = str(tag) + "." + str(monat) + "." + str(jahr)
    return(systemDatum, systemUhrzeit, zeitpunktMessung)

def ledAusgabe(messWert):

    if messWert < minTempUser:
        print "Gemessene Temperatur von ", messWert, " unter dem definierten Wert von ", minTempUser, "!"
        ledSteuerung(25)
        rueckgabe = 1
    elif messWert > maxTempUser:
        print "Gemessene Temperatur von ", messWert, " über dem definierten Wert von ", maxTempUser, "!"
        ledSteuerung(24)
        rueckgabe = 2
    else:
        print "Gemessene Temperatur von ", messWert," im gewünschten Bereich von ", minTempUser, " und ", maxTempUser
        ledSteuerung(18)
        rueckgabe = 3
    return(rueckgabe)

def ledSteuerung(steuerWert):
    if steuerWert == 0:
        gp.output(18, gp.LOW)
        gp.output(24, gp.LOW)
        gp.output(25, gp.LOW)
    elif steuerWert == 18:
        gp.output(24, gp.LOW)
        gp.output(25, gp.LOW)
        gp.output(18, gp.HIGH)
    elif steuerWert == 24:
        gp.output(18, gp.LOW)
        gp.output(25, gp.LOW)
        gp.output(24, gp.HIGH)
    elif steuerWert == 25:
        gp.output(18, gp.LOW)
        gp.output(24, gp.LOW)
        gp.output(25, gp.HIGH)
    else:
        print "Falscher Übergabewert in ledSteuerung()"
 

def userTempWerte_db_anlegen():
    # Temperatur-Werte für erste Inbetriebnahme    
    minTempSensor = -50.00 # Messbereich Sensor Untergerenze
    maxTempSensor = 125.00 # Messbereich Sensor Obergrenze
    minTempUser = 20.00 # Benutzerdefinierte Untergrenze der Temperatur
    maxTempUser = 21.00 # Benutzerdefinierte Obergrenze der Temperatur
    connection = sqlite3.connect("/var/www/tempdata.db")
    cursor = connection.cursor()
    # Tabelle erzeugen
    sql = "CREATE TABLE tempWerte("\
        "minTempSensor FLOAT, maxTempSensor FLOAT, minTempUser FLOAT, maxTempUser FLOAT) " 
    cursor.execute(sql)
    # Werte für erste Inbetriebnahme
    sql = "INSERT INTO tempWerte VALUES(" + str(minTempSensor) + ", " + str(maxTempSensor) + ", " \
          + str(minTempUser) + ", " + str(maxTempUser) + ")"
    cursor.execute(sql)
    connection.commit()
    connection.close()
    print "Datenbank tempdata.db mit ", sql ," Inhalt angelegt"

def userTempWerte_db_auslesen():
    global minTempSensor, maxTempSensor, minTempUser, maxTempUser
    
    connection = sqlite3.connect("/var/www/tempdata.db")
    cursor = connection.cursor()
    sql = "SELECT * FROM tempWerte"
    cursor.execute(sql)
    for dsatz in cursor:
        minTempSensor = dsatz[0]
        maxTempSensor = dsatz[1]
        minTempUser = dsatz[2]
        maxTempUser = dsatz[3]
    connection.close()
    return ()

def userTempWerte_db_schreiben(datenVonApp):
    neuerDSatz = datenVonApp.split('|')
    connection = sqlite3.connect("/var/www/tempdata.db")
    cursor = connection.cursor()
    
    if neuerDSatz[1] == "minTempUser":
        sql = "UPDATE tempWerte SET minTempUser = '" + neuerDSatz[2] + "'"

    elif neuerDSatz[1] == "maxTempUser":
        sql = "UPDATE tempWerte SET maxTempUser = '" + neuerDSatz[2] +"'"
        
    elif neuerDSatz[1] == "minTempSensor":
        sql = "UPDATE tempWerte SET minTempSensor = '" + neuerDSatz[2] +"'"

    elif neuerDSatz[1] == "maxTempSensor":
        sql = "UPDATE tempWerte SET maxTempSensor = '" + neuerDSatz[2] + "'"
        
    cursor.execute(sql)
    connection.commit()
    connection.close()
    print "Datenbank tempdate.db mit ", sql ," Inhalt geändert."


def tempDaten_db_schreiben():
    a = 0
    if not os.path.exists("/var/www/aufzeichnungen.db"):
        # Datenbank nicht vorhanden.
        sqlAnlage = "CREATE TABLE werte(datum TEXT, uhrzeit TEXT, temperatur FLOAT)"
        a = 1
        print "Datenbank für Aufzeichnungen angelegt."
        
    connection = sqlite3.connect("/var/www/aufzeichnungen.db")
    cursor = connection.cursor()

    if a == 1 :
        # Tabelle erzeugen
        cursor.execute(sqlAnlage)
        
    # Werte der Messung hinzufügen
    dSatz = messDatenString.split('|')
    datum = dSatz[2]
    uhrzeit = dSatz[3]
    temperatur = dSatz[0]
    
    sql = "INSERT INTO werte VALUES('" + datum + "', '" + uhrzeit + "', " + temperatur + ")"
    print "Daten für Erweiterung der Aufzeichnungen: ", sql
    cursor.execute(sql)
    connection.commit()
    connection.close()

# GPIO für LED Steuerung initialisieren
gp.setmode(gp.BCM) # BCM Nummern verwenden
gp.setwarnings(False) # Warnmeldungen abschalten
gp.setup(18, gp.OUT) # Pin12 - BCM Nummer 18 - GPIO1 wird Ausgang
gp.setup(24, gp.OUT) # Pin18 - BCM Nummer 24 - GPIO5 wird Ausgang
gp.setup(25, gp.OUT) # Pin22 - BCM Nummer 25 - GPIO6 wird Ausgang


# Existenz der Datenbank für Temperartur-Werte-Einstellungen des Benutzers überprüfen und ggf. diese anlegen
if not os.path.exists("/var/www/tempdata.db"):
    print "Datenbank tempdata.db nicht vorhanden - Datenbank wird anglegt."
    userTempWerte_db_anlegen()

# Temperatur-Werte aus Datenbank auslesen
userTempWerte_db_auslesen()

print "Warte auf Verbindung mit WEB-Interface."

class WSHandler(tornado.websocket.WebSocketHandler):

    def check_origin(self, origin):
        
        return True
    
    def open(self):
        self.connected = True
        print "Verbindung mit WEB-Interface aufgebaut."
        self.timeout_loop()
 
    def on_message(self, message):
        
        print "Übergabewert von WEB-Interface: ", message

        if message == "aufzeichnung":
            print "Aufzeichnung der Daten der letzten Temperaturmessung."
            tempDaten_db_schreiben()
        elif "tempwechsel" in message:
            print "Änderung der Temperaturwerte."
            userTempWerte_db_schreiben(message)
            userTempWerte_db_auslesen()
        elif "scheduler" in message:
            print "Scheduleraufzeichnung."
            schedulerAusfuehren(message)
        else:
            print "unbekannter Befehl"
                    
    def on_close(self):
        self.connected = False
        print "Verbindung zum WEB-Interface geschlossen."
        self.timeout_loop()


    def timeout_loop(self):
        # global reset
        global messDatenString
        if self.connected:
   
            systemMessDaten = aktuelleTemperatur() # Rückgabe: 0=aktuelle Temperatur 1=Status zu benutzerdefinierten Bereich 2=Differenz zu Unterwert-Messbereich 3=Different zu Oberwert-Messbereich

            systemZeit = aktuelleSystemZeit() # Rückgabe: 0=Datum 1=Uhrzeit 2=Systemwert

            
            print "Temperatur: ",systemMessDaten[0],"°C mit Status ", systemMessDaten[1], "am ",systemZeit[0]," um ",systemZeit[1], "liegt ",systemMessDaten[3],"°C unter der Obergrenze und ",systemMessDaten[2],"°C über der Untergrenze der Sensor-Messbereich."

            messDatenString = systemMessDaten[0] + "|" + systemMessDaten[1] + "|" + systemZeit[0] + "|" + systemZeit[1] + "|" + systemMessDaten[2] + "|" + systemMessDaten[3]  + "|" + str(systemZeit[2]) + "|" + str(minTempSensor) + "|" + str(maxTempSensor) + "|" + str(minTempUser) + "|" + str(maxTempUser)

            self.write_message(messDatenString)
            
            tornado.ioloop.IOLoop.instance().add_timeout(datetime.timedelta(seconds=.1), self.timeout_loop)
        else:
            aktuelleTemperatur()
            tornado.ioloop.IOLoop.instance().add_timeout(datetime.timedelta(seconds=1), self.timeout_loop)

application = tornado.web.Application([(r'/ws', WSHandler),])

if __name__ == "__main__":
    http_server = tornado.httpserver.HTTPServer(application)
    http_server.listen(8888)
    tornado.ioloop.IOLoop.instance().start()
